Boolean 方法 (ActiveX)
在对象与另一个 3DSolid 或 Region 对象之间执行布尔运算(并集、相交或减法)。 支持的平台:仅限 Windows 签名VBA: object.Boolean(Operation, Object) 返回值 (RetVal)无返回值。 言论第一个对象将作为操作的结果进行修改。 布尔相交前的实体 布尔交集生成的实体 注意:如果操作没有结果,则不会更改第一个对象。例如,在查找两个不相交对象之间的交点时,第一个对象没有变化。
例子VBA: Sub Example_Boolean() ' This example creates a box and a cylinder in model space. ' It then performs a Boolean operation on the two solids. Dim boxObj As Acad3DSolid Dim boxLength As Double, boxWidth As Double, boxHeight As Double Dim boxCenter(0 To 2) As Double boxCenter(0) = 5#: boxCenter(1) = 5#: boxCenter(2) = 0 boxLength = 10#: boxWidth = 7: boxHeight = 10# ' Create the box (3DSolid) object in model space Set boxObj = ThisDrawing.ModelSpace.AddBox(boxCenter, boxLength, boxWidth, boxHeight) ' Define the cylinder Dim cylinderObj As Acad3DSolid Dim cylinderCenter(0 To 2) As Double Dim cylinderRadius As Double Dim cylinderHeight As Double cylinderCenter(0) = 0#: cylinderCenter(1) = 0#: cylinderCenter(2) = 0# cylinderRadius = 5# cylinderHeight = 20# ' Create the Cylinder (3DSolid) object in model space Set cylinderObj = ThisDrawing.ModelSpace.AddCylinder(cylinderCenter, cylinderRadius, cylinderHeight) ' Change the viewing direction of the viewport Dim NewDirection(0 To 2) As Double NewDirection(0) = -1: NewDirection(1) = -1: NewDirection(2) = 1 ThisDrawing.ActiveViewport.direction = NewDirection ThisDrawing.ActiveViewport = ThisDrawing.ActiveViewport ZoomAll ' Perform an intersection on the two solids MsgBox "Perform an intersection on the two solids.", vbOKOnly, "Boolean Example" boxObj.Boolean acIntersection, cylinderObj ThisDrawing.Regen True MsgBox "Intersection complete.", , "Boolean Example" End Sub 可视化 LISP: (vl-load-com) (defun c:Example_Boolean() ;; This example creates a box and a cylinder in model space. ;; It then performs a Boolean operation on the two solids. (setq acadObj (vlax-get-acad-object)) (setq doc (vla-get-ActiveDocument acadObj)) (setq boxCenter (vlax-3d-point 5 5 0) boxLength 10 boxWidth 7 boxHeight 10) ;; Create the box (3DSolid) object in model space (setq modelSpace (vla-get-ModelSpace doc)) (setq boxObj (vla-AddBox modelSpace boxCenter boxLength boxWidth boxHeight)) ;; Define the cylinder (setq cylinderCenter (vlax-3d-point 0 0 0) cylinderRadius 5 cylinderHeight 20) ;; Create the Cylinder (3DSolid) object in model space (setq cylinderObj (vla-AddCylinder modelSpace cylinderCenter cylinderRadius cylinderHeight)) ;; Change the viewing direction of the viewport (setq NewDirection (vlax-3d-point -1 -1 1)) (setq activeViewport (vla-get-ActiveViewport doc)) (vla-put-Direction activeViewport NewDirection) (vla-put-ActiveViewport doc activeViewport) (vla-ZoomAll acadObj) ;; Perform an intersection on the two solids (alert "Perform an intersection on the two solids.") (vla-Boolean boxObj acIntersection cylinderObj) (vla-Regen doc :vlax-true) (alert "Intersection complete.") ) |
|Archiver|CAD开发者社区 ( 苏ICP备2022047690号-1 苏公网安备32011402011833)
GMT+8, 2025-1-19 06:49
Powered by Discuz! X3.4
Copyright © 2001-2021, Tencent Cloud.